From fb77ae530a8ed4eb3c9485e4bb6d60fa77dc4e3d Mon Sep 17 00:00:00 2001
From: Yuan Fu <casouri@gmail.com>
Date: Sat, 18 Jan 2020 13:58:17 -0500
Subject: [PATCH] Fix gdb-mi opens new window to display source file
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

By design it shouldn’t, the problem is gud-display-line uses
display-buffer instead of gdb-display-source-buffer.

* lisp/progmodes/gud.el (gud-display-line): use
gdb-display-source-buffer when running gdb-mi
---
 lisp/progmodes/gud.el | 2 ++
 1 file changed, 2 insertions(+)

diff --git a/lisp/progmodes/gud.el b/lisp/progmodes/gud.el
index d5fd1dce6f..a81b8996cf 100644
--- a/lisp/progmodes/gud.el
+++ b/lisp/progmodes/gud.el
@@ -2829,6 +2829,8 @@ gud-display-line
 	    (gud-find-file true-file)))
 	 (window (and buffer
 		      (or (get-buffer-window buffer)
+                          (when (eq gud-minor-mode 'gdbmi)
+                            (gdb-display-source-buffer buffer))
 			  (display-buffer buffer '(nil (inhibit-same-window . t))))))
 	 (pos))
     (when buffer
-- 
2.24.1

